import { Decoder, DecoderDict, DecoderValueDict } from "./shared";
export declare type Composeable = <Decoders extends Array<Decoder<any>>>(...decoders: Decoders) => Decoder<Decoders[number] extends Decoder<infer T> ? T : never>;
export declare type Map = <Decoders extends Array<Decoder<any>>, T>(f: (...values: Array<Decoders[number] extends Decoder<infer U> ? U : never>) => T, ...decoders: Decoders) => Decoder<T>;
export declare type Union = <T extends string | number | boolean, Values extends Array<T>>(decoder: Decoder<T>, ...values: Values) => Decoder<Values[number]>;
export declare const str: Decoder<string>;
export declare const num: Decoder<number>;
export declare const bool: Decoder<boolean>;
export declare const nil: Decoder<null>;
export declare const array: <T>(decoder: Decoder<T>) => Decoder<T[]>;
export declare const oneOf: Composeable;
export declare const nullable: <T>(decoder: Decoder<T>) => Decoder<T | null>;
export declare const maybe: <T>(decoder: Decoder<T>) => Decoder<T | undefined>;
export declare const union: Union;
export declare const object: <T extends DecoderDict>(decoders: T) => Decoder<DecoderValueDict<T>>;
export declare const field: <T>(name: string, decoder: Decoder<T>) => Decoder<T>;
export declare const compose: Composeable;
export declare const map: Map;
